#if !defined(AFX_DICT_H__EAE5522F_2699_4309_B229_B693161A200D__INCLUDED_)
#define AFX_DICT_H__EAE5522F_2699_4309_B229_B693161A200D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Dict.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDict window

#define FormatEUC 1
#define FormatUTF8 2
#define FormatUTF16 3

class CDict
{
// Construction
public:
	CDict();

// Attributes
private:
	unsigned char * dictionary;		// main dictionary
	long length;					// length of dictionary
	HANDLE hDict;					// Handle for memory mapped file
	int format;						// Format EUC, UTF8, or UTF16
	bool memfile;					// Dictionary has been allocated new memory
	
	long * index;					// index table, 4 bytes per entry
	long indexLength;				// length of index table
	HANDLE hIndex;					// Handle for memory mapped file

// Operations
public:
	bool InitDict(CString file, CString indexfile);
	bool MakeDict(CString file);
	CString Find(int flags, CString inputstring);

private:
	CString FindNoIndex(int searchflag, WCHAR * str);
	CString FindWithIndex(int searchflag, WCHAR * str);

	CString OutputLine(unsigned char * p1);
	int WordLength(WCHAR * str);

	unsigned char * CDict::Kstrstr(unsigned char * p, WCHAR * q);
	unsigned char * KstrstrEUC(unsigned char * p, WCHAR * q);
	unsigned char * KstrstrUTF8(unsigned char * p, WCHAR * q);
	WCHAR * KstrstrUTF16(WCHAR * p, WCHAR * q);

	int Kstrcmp(unsigned char * p, WCHAR * q);
	int KstrcmpEUC(unsigned char * p, WCHAR * q);
	int KstrcmpUTF8(unsigned char * p, WCHAR * q);
	int KstrcmpUTF16(WCHAR * p, WCHAR * q);

// Implementation
public:
	virtual ~CDict();
};

/////////////////////////////////////////////////////////////////////////////


#endif // !defined(AFX_DICT_H__EAE5522F_2699_4309_B229_B693161A200D__INCLUDED_)
