// JPenWnd.h

// Returns number of elements
#define dim(x) (sizeof(x) / sizeof(x[0]))   

struct decodeUINT {                            // structure associates
    UINT Code;                                 // messages with a function 
    LRESULT (*Fxn)(HWND, UINT, WPARAM, LPARAM);
}; 

#define MYSIPCLS       TEXT ("JPenSIPWndCls")
#define MYMSG_METHCALL (WM_USER+100)           // Used to pass info

#define FLOATWIDTH     200                     // Width of floating wnd
#define FLOATHEIGHT    100                     // height of floating wnd

#define GRIDSIZE 70
#define GRIDX 155
#define GRIDY 3
#define KEYSIZE 27
#define KEYX 10
#define KEYY 4
#define KEYCOL 5
#define KEYROW 2
#define BESTSIZE (KEYCOL*KEYROW)

//
// Local data structure for keypad IM window.
//

typedef struct {
	DWORD dwBtnDnFlags;
	IIMCallback *pIMCallback;
	RECT rectDocked;
	BOOL fMoving;
	POINT ptMovBasis;
	POINT ptMovStart;
	IMINFO imi;
} SIPWNDSTRUCT, *LPSIPWNDSTRUCT;

LRESULT CALLBACK JPenWndProc (HWND, UINT, WPARAM, LPARAM);

LRESULT CALLBACK DoCreateSip(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DoSetSipInfo(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DoPaintSip(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DoLButtonDownSip(HWND hWnd, UINT wMsg, WPARAM nFlags, LPARAM lParam);
LRESULT CALLBACK DoMouseMoveSip(HWND hWnd, UINT wMsg, WPARAM nFlags, LPARAM lParam);
LRESULT CALLBACK DoLButtonUpSip(HWND hWnd, UINT wMsg, WPARAM nFlags, LPARAM lParam);
LRESULT CALLBACK DoDestroySip(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DoTimerSip(HWND, UINT, WPARAM, LPARAM);

static POINT GridLines[13] = {
	{ GRIDX+GRIDSIZE/4, GRIDY },
	{ GRIDX+GRIDSIZE/4, GRIDY+GRIDSIZE },
	{ GRIDX+GRIDSIZE/2, GRIDY+GRIDSIZE },
	{ GRIDX+GRIDSIZE/2, GRIDY },
	{ GRIDX+GRIDSIZE*3/4, GRIDY },
	{ GRIDX+GRIDSIZE*3/4, GRIDY+GRIDSIZE },
	{ GRIDX+GRIDSIZE, GRIDY+GRIDSIZE },
	{ GRIDX+GRIDSIZE, GRIDY+GRIDSIZE*3/4 },
	{ GRIDX, GRIDY+GRIDSIZE*3/4 },
	{ GRIDX, GRIDY+GRIDSIZE/2 },
	{ GRIDX+GRIDSIZE, GRIDY+GRIDSIZE/2 },
	{ GRIDX+GRIDSIZE, GRIDY+GRIDSIZE/4 },
	{ GRIDX, GRIDY+GRIDSIZE/4 }
};

static POINT Grid[5] = {
	{ GRIDX, GRIDY },
	{ GRIDX+GRIDSIZE, GRIDY },
	{ GRIDX+GRIDSIZE, GRIDY+GRIDSIZE },
	{ GRIDX, GRIDY+GRIDSIZE },
	{ GRIDX, GRIDY }
};
